# Structure Web Application Framework

A NodeJS TypeScript web application framework (duh).

## /!\ Still in development! There are not near enough tests /!\

Use at your own risk. Also please feel free to contribute with issues, bug reports and pull requests.

## Features

### Application building

- Model, View, Controller
- Uses express
- Custom Middleware classes that enable advanced modularity
- Modular models (you can add components with some definition automation)
- Simple database migrations (raw sql queries for now)
- Nunjucks for the view template engine
- Mail template system using Nunjucks + MJML
- Beautiful logging thanks to `tslog`

### Databases

- MySQL (persistent data)
- Redis (cache, session)
- (more to come)

### Common systems

- Advanced modular multi-factor authentication system
- CSRF protection
- WebSocket server with Controller-style endpoint listeners
- WIP: automatic updates
