import Migration from "../../db/Migration";

export default class AddUsedToMagicLinksMigration extends Migration {
    public async install(): Promise<void> {
        await this.query(`ALTER TABLE magic_links
            ADD COLUMN used BOOLEAN NOT NULL`);
        await this.query(`DELETE FROM magic_links`);
    }

    public async rollback(): Promise<void> {
        await this.query('ALTER TABLE magic_links DROP COLUMN IF EXISTS used');
    }
}
