import Migration from "../../db/Migration";

export default class MakeMagicLinksSessionNotUniqueMigration extends Migration {
    public async install(): Promise<void> {
        await this.query(`ALTER TABLE magic_links
            DROP INDEX IF EXISTS session_id`);
    }

    public async rollback(): Promise<void> {
        await this.query('ALTER TABLE magic_links ADD CONSTRAINT UNIQUE (session_id)');
    }
}
