import Migration from "../../db/Migration";

export default class AddNameChangedAtToUsersMigration extends Migration {
    public async install(): Promise<void> {
        await this.query(`ALTER TABLE users
            ADD COLUMN name_changed_at DATETIME`);
    }

    public async rollback(): Promise<void> {
        await this.query('ALTER TABLE users DROP COLUMN IF EXISTS name_changed_at');
    }
}
